!!ARBvp1.0

PARAM mvp[4] = { state.matrix.mvp };

ATTRIB iVertex = vertex.position;
ATTRIB iNormal = vertex.normal;

PARAM lightPos   = program.env[0];
PARAM camPos     = program.env[1];
PARAM shadowMat0 = program.env[2];
PARAM shadowMat1 = program.env[3];
PARAM shadowMat2 = program.env[4];
PARAM shadowMat3 = program.env[5];
PARAM dirX       = program.local[0];
PARAM dirZ       = program.local[1];
PARAM yParams    = program.local[2];

OUTPUT oPos        = result.position;
OUTPUT pos         = result.texcoord[0];
OUTPUT shadowCoord = result.texcoord[1];
OUTPUT normal      = result.texcoord[2];
OUTPUT lightVec    = result.texcoord[3];
OUTPUT viewVec     = result.texcoord[4];

TEMP position, lv, shadowCrd, coord;

DP4	position.x, iVertex, dirX;
#ADD	position.y, iVertex.y, yParams.x;
MAD	position.y, iVertex.y, yParams.x, yParams.y;
DP4	position.z, iVertex, dirZ;
MOV	position.w, 1;

DP4 oPos.x, mvp[0], position;
DP4 oPos.y, mvp[1], position;
DP4 oPos.z, mvp[2], position;
DP4 oPos.w, mvp[3], position;

MUL	pos, iVertex, 0.08;

DP4 shadowCrd.x, shadowMat0, position;
DP4 shadowCrd.y, shadowMat1, position;
DP4 shadowCrd.z, shadowMat2, position;
DP4 shadowCrd.w, shadowMat3, position;

ADD	shadowCrd.z, shadowCrd.z, 1;

ADD	coord.x, shadowCrd.z, shadowCrd.x;
ADD	coord.y, shadowCrd.z, shadowCrd.y;
MUL	shadowCoord.xy, coord, 0.5;
MOV	shadowCoord.z, 0;
MOV	shadowCoord.w, shadowCrd.z;

DP3	normal.x, iNormal, dirX;
MOV	normal.y, iNormal.y;
DP3	normal.z, iNormal, dirZ;

SUB	lv, lightPos, position;
MUL	lightVec, lv, 0.001;

SUB	viewVec,  camPos,   position;

END
